#!/usr/bin/env python

#this is a client to match happynsm to make it easier to look at node problems
#debug needs to be implemented

from sss.ssslib import comm_lib
from elementtree.ElementTree import XML, tostring, Element
from getopt import getopt, GetoptError
from sys import argv,exit
from string import join

if __name__ == '__main__':
    try:
        (opts,args) = getopt(argv[1:],'gdn:t:')
    except GetoptError, e:
        print e
        print "Usage: amihappy-client -g [-n node[,node,node...]] [-t executable-name[,executable-name]]","\n","Usage2: amihappy-client -d [-n node[,node,node...]] [-t test-name[,test-name]]"
        exit(1)

    mode='none'
    for x in opts:
        if (x[0] == '-d'):
            mode='diagnose'

    if (mode=='diagnose'):
        nodes =[x[1] for x in opts if x[0] == '-n']
        tests = [x[1] for x in opts if x[0] == '-t']

        xmldmesg = Element("diagnose")
        if nodes:
            xmldmesg.set("node",nodes[0])
        else:
            print("must specify list of hosts to test")
            exit(1)
        if tests:
            xmldmesg.set("test",tests[0])
        else:
            xmldmesg.set("test","all")

        #xmldmesg.set("uniqueID","*")

        comm = comm_lib(debug=0)
        h = comm.ClientInit('node-state-manager')
        comm.SendMessage(h,tostring(xmldmesg))
        msg = comm.RecvMessage(h)


        print msg
        print "the features that actually display results now are not yet implemented.","it is suggested that you run this tool in Get(-g) mode after waiting a bit for the tests to complete","you are welcome to implement the feature at your leisure"
              

        exit(1)

        #the uniqueID should be returned by the happy-nsm(it is currently not created or returned)
        #that uniqueID should be parsed out of msg and put in to the xmlrecvmesg
        #we should go in to a loop here to wait for the happy-nsm to send back an event that that uniqueID finished
        xmlrecvmesg = Element("wait-diagnosis",uniqueID=something)
        nodestate = Element("node-state", host="*", state="*", adminstate="*")
        nodestate.append(Element("testresult",status="*",test="*",output="*"))
        xmlrecvmesg.append(nodestate)
        
        del msg
        comm.SendMessage(h,tostring(xmlrecvmesg))
        msg = comm.RecvMessage(h)

    else:
        xmlgmesg = Element("get-node-state")
        #its all wrong below here

        if something:
            testresult = Element("testresult",test="foo",etc=null)
        comm = comm_lib(debug=0)
        h = comm.ClientInit('node-state-manager')
        comm.SendMessage(h,tostring(xmlgmesg))
        msg = comm.RecvMessage(h)

        print "results:",msg
