#!/usr/bin/env python

from sys import argv,exit
from time import gmtime, strftime
from sss.ssslib import comm_lib

if len(argv) < 4:
    print "Usage: event_send.py <component> <message> <data>"
    exit(1)

component,msg,data = argv[1:]

comm = comm_lib(debug=1)

h = comm.ClientInit("event-manager")

event = '<?xml version="1.0" ?><add-event><event><component>%s</component><msg>%s</msg><data>%s</data><time>%s</time></event></add-event>'

time = strftime("%c",gmtime())

comm.SendMessage(h,event%(component,msg,data,time))

resp = comm.RecvMessage(h)

comm.ClientClose(h)
